# git-log(1) Manual Page

## NAME

git-log - Show commit logs

## SYNOPSIS

git-log <option>…

## DESCRIPTION

Shows the commit logs.

The command takes options applicable to the git-rev-list(1) command to control what is shown and how, and options applicable to the git-diff-tree(1) commands to control how the changes each commit introduces are shown.

This manual page describes only the most frequently used options.

## OPTIONS

--pretty[=<format>]

  Pretty print the contents of the commit logs in a given format, where <format> can be one of oneline, short, medium, full, fuller, email, raw and format:<string>. When left out the format default to medium.

--encoding[=<encoding>]

  The commit objects record the encoding used for the log message in their encoding header; this option can be used to tell the command to re-code the commit log message in the encoding preferred by the user. For non plumbing commands this defaults to UTF-8.

-<n>

  Limits the number of commits to show.

<since>..<until>

  Show only commits between the named two commits. When either <since> or <until> is omitted, it defaults to `HEAD`, i.e. the tip of the current branch. For a more complete list of ways to spell <since> and <until>, see "SPECIFYING REVISIONS" section in git-rev-parse(1).

--first-parent

  Follow only the first parent commit upon seeing a merge commit. This option gives a better overview of the evolution of a particular branch.

-p

  Show the change the commit introduces in a patch form.

-g, --walk-reflogs

  Show commits as they were recorded in the reflog. The log contains a record about how the tip of a reference was changed. See also git-reflog(1).

--decorate

  Print out the ref names of any commits that are shown.

<paths>…

  Show only commits that affect the specified paths.

## PRETTY FORMATS

If the commit is a merge, and if the pretty-format is not oneline, email or raw, an additional line is inserted before the Author: line. This line begins with "Merge: " and the sha1s of ancestral commits are printed, separated by spaces. Note that the listed commits may not necessarily be the list of the direct parent commits if you have limited your view of history: for example, if you are only interested in changes related to a certain directory or file.

Here are some additional details for each format:

- oneline

      <sha1> <title line>

  This is designed to be as compact as possible.

- short

      commit <sha1>
      Author: <author>

      <title line>

- medium

      commit <sha1>
      Author: <author>
      Date: <date>

      <title line>

      <full commit message>

- full

      commit <sha1>
      Author: <author>
      Commit: <committer>

      <title line>

      <full commit message>

- fuller

      commit <sha1>
      Author: <author>
      AuthorDate: <date & time>
      Commit: <committer>
      CommitDate: <date & time>

      <title line>

      <full commit message>

- email

      From <sha1> <date>
      From: <author>
      Date: <date & time>
      Subject: [PATCH] <title line>

      <full commit message>

- raw

  The raw format shows the entire commit exactly as stored in the commit object. Notably, the SHA1s are displayed in full, regardless of whether --abbrev or --no-abbrev are used, and parents information show the true parent commits, without taking grafts nor history simplification into account.

- format:

  The format: format allows you to specify which information you want to show. It works a little bit like printf format, with the notable exception that you get a newline with %n instead of \n.

  E.g, format:"The author of %h was %an, %ar%nThe title was >>%s<<%n" would show something like this:

      The author of fe6e0ee was Junio C Hamano, 23 hours ago
      The title was >>t4119: test autocomputing -p<n> for traditional diff input.<<

  The placeholders are:

  - %H: commit hash

  - %h: abbreviated commit hash

  - %T: tree hash

  - %t: abbreviated tree hash

  - %P: parent hashes

  - %p: abbreviated parent hashes

  - %an: author name

  - %ae: author email

  - %ad: author date

  - %aD: author date, RFC2822 style

  - %ar: author date, relative

  - %at: author date, UNIX timestamp

  - %cn: committer name

  - %ce: committer email

  - %cd: committer date

  - %cD: committer date, RFC2822 style

  - %cr: committer date, relative

  - %ct: committer date, UNIX timestamp

  - %e: encoding

  - %s: subject

  - %b: body

  - %Cred: switch color to red

  - %Cgreen: switch color to green

  - %Cblue: switch color to blue

  - %Creset: reset color

  - %m: left, right or boundary mark

  - %n: newline

## Examples

git log --no-merges

  Show the whole commit history, but skip any merges

git log v2.6.12.. include/scsi drivers/scsi

  Show all commits since version v2.6.12 that changed any file in the include/scsi or drivers/scsi subdirectories

git log --since="2 weeks ago" -- gitk

  Show the changes during the last two weeks to the file gitk. The "--" is necessary to avoid confusion with the branch named gitk

git log -r --name-status release..test

  Show the commits that are in the "test" branch but not yet in the "release" branch, along with the list of paths each commit modifies.

## Discussion

At the core level, git is character encoding agnostic.

- The pathnames recorded in the index and in the tree objects are treated as uninterpreted sequences of non-NUL bytes. What readdir(2) returns are what are recorded and compared with the data git keeps track of, which in turn are expected to be what lstat(2) and creat(2) accepts. There is no such thing as pathname encoding translation.

- The contents of the blob objects are uninterpreted sequence of bytes. There is no encoding translation at the core level.

- The commit log messages are uninterpreted sequence of non-NUL bytes.

Although we encourage that the commit log messages are encoded in UTF-8, both the core and git Porcelain are designed not to force UTF-8 on projects. If all participants of a particular project find it more convenient to use legacy encodings, git does not forbid it. However, there are a few things to keep in mind.

1. `git-commit-tree` (hence, `git-commit` which uses it) issues an warning if the commit log message given to it does not look like a valid UTF-8 string, unless you explicitly say your project uses a legacy encoding. The way to say this is to have i18n.commitencoding in `.git/config` file, like this:

       [i18n]
               commitencoding = ISO-8859-1

   Commit objects created with the above setting record the value of `i18n.commitencoding` in its `encoding` header. This is to help other people who look at them later. Lack of this header implies that the commit log message is encoded in UTF-8.

2. `git-log`, `git-show` and friends looks at the `encoding` header of a commit object, and tries to re-code the log message into UTF-8 unless otherwise specified. You can specify the desired output encoding with `i18n.logoutputencoding` in `.git/config` file, like this:

       [i18n]
               logoutputencoding = ISO-8859-1

   If you do not have this configuration variable, the value of `i18n.commitencoding` is used instead.

Note that we deliberately chose not to re-code the commit log message when a commit is made to force UTF-8 at the commit object level, because re-coding to UTF-8 is not necessarily a reversible operation.

## Author

Written by Linus Torvalds <torvalds@osdl.org>

## Documentation

Documentation by David Greaves, Junio C Hamano and the git-list <git@vger.kernel.org>.

## GIT

Part of the git(7) suite